//
// PS2PC: An Intel x86 emulator for MIPS R5900 (Sony PS2).
// Coded by Mike Tedder / breakpoint - bpoint@parodius.com
// http://ps2pc.parodius.com
//
// This project is released as 'open source'.  You may make any modifications
// or adjustments to the code and submit a patch to be applied to the project.
// See the web page for more details.
//
//-----------------------------------------------------------------------

#ifndef TYPES_H
#define TYPES_H

#ifndef NULL
#ifdef  __cplusplus
#define NULL				0
#else
#define NULL				((void *)0)
#endif
#endif

#ifdef NO_EXTERN
#define GLOBAL
#else
#define GLOBAL extern
#endif

#ifdef DO_DEBUG
#define DEBUG_VER(x);		x;
#else
#define DEBUG_VER(x);		;
#endif

#define ASMFUNC				extern "C"

#define FALSE               0
#define TRUE                1

#define HI_WORD(x)          ((x) >> 16)
#define LO_WORD(x)          ((x) & 0x0000FFFF)

#define HI_BYTE(x)          ((x) >> 8)
#define LO_BYTE(x)          ((x) & 0x00FF)

#define MAKE_WORD(u, l)					((u << 8) | (l))
#define MAKE_DWORD(uu, ul, lu, ll)		((uu << 24) | (ul << 16) | (lu << 8) | ll)

//typedef unsigned char       bool;

typedef unsigned char       uchar;
typedef unsigned short      ushort;
typedef unsigned int        uint;
typedef unsigned long       ulong;

typedef   signed char       schar;
typedef   signed short      sshort;
typedef   signed int        sint;
typedef   signed long       slong;

#endif
