//
// PS2PC: An Intel x86 emulator for MIPS R5900 (Sony PS2).
// Coded by Mike Tedder / breakpoint - bpoint@parodius.com
// http://ps2pc.parodius.com
//
// This project is released as 'open source'.  You may make any modifications
// or adjustments to the code and submit a patch to be applied to the project.
// See the web page for more details.
//
//-----------------------------------------------------------------------

#include "types.h"

int x86JMP_Jv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JMP_Ap(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JMP_Jb(uchar *in, ulong *out, bool *isBranch, ulong *skip);

int x86JO(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JNO(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JB(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JNB(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JZ(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JNZ(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JBE(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JNBE(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JS(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JNS(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JP(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JNP(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JL(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JNL(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JLE(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JNLE(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86JCXZ_Jb(uchar *in, ulong *out, bool *isBranch, ulong *skip);

int x86LOOP_Jb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86LOOPE_Jb(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86LOOPNE_Jb(uchar *in, ulong *out, bool *isBranch, ulong *skip);

int x86CALL_Ap(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86CALL_Jv(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86RET_Iw(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86RET(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86RETF_Iw(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86RETF(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86IRET(uchar *in, ulong *out, bool *isBranch, ulong *skip);

int x86INT_3(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86INT_Ib(uchar *in, ulong *out, bool *isBranch, ulong *skip);
int x86INTO(uchar *in, ulong *out, bool *isBranch, ulong *skip);
